library props_flutter_notificationsdk;

import 'package:device_info_plus/device_info_plus.dart';
import 'package:http/http.dart' as http;
import 'package:firebase_messaging/firebase_messaging.dart';

class PropsFlutterNotificationsdk {
  PropsFlutterNotificationsdk._privateConstructor();
  static final PropsFlutterNotificationsdk instance = PropsFlutterNotificationsdk._privateConstructor();
  String coriginKeys;

  PropsFlutterNotificationsdk(){
  }

  void setCoriginKeys(String coriginKeys) {
    this.coriginKeys = coriginKeys;
  }

  String getCoriginKeys() {
    return this.coriginKeys;
  }

  Future<void> registerUserData() async {
    DeviceInfoPlugin deviceInfo = DeviceInfoPlugin();
    AndroidDeviceInfo androidInfo = await deviceInfo.androidInfo;
    FirebaseMessaging _fbm = FirebaseMessaging();
    print('Running on ${androidInfo.model}');  // e.g. "Moto G (4)"

    _fbm.getToken().then((token) async {
      var fullUrl = "https://apiapps.props.id/registerUser?deviceId=${androidInfo.model}&brand=${androidInfo.brand}&uuid=${androidInfo.androidId}&messagingToken=${token}";
      var url = Uri.parse(fullUrl);
      Map<String, String> headers = {
        "Authorization": PropsFlutterNotificationsdk.instance.getCoriginKeys()
      };
      var test = await http.get(url, headers: headers);
      print("YODAZO HTTPGET ${test.statusCode}");
      return;
    });
  }

  Future<void> logMessageReceived(String notificationId) async {
    DeviceInfoPlugin deviceInfo = DeviceInfoPlugin();
    AndroidDeviceInfo androidInfo = await deviceInfo.androidInfo;
    FirebaseMessaging _fbm = FirebaseMessaging();
    print('Running on ${androidInfo.model}');  // e.g. "Moto G (4)"

    _fbm.getToken().then((token) async {
      var fullUrl = "https://apiapps.props.id/logMessageReceived?notificationId=${notificationId}&uuid=${androidInfo.androidId}";
      var url = Uri.parse(fullUrl);
      Map<String, String> headers = {
        "Authorization": PropsFlutterNotificationsdk.instance.getCoriginKeys()
      };
      var test = await http.get(url, headers: headers);
      print("YODAZO HTTPGET ${test.statusCode}");
      return;
    });
  }

  Future<void> logMessageOpened(String notificationId) async {
    DeviceInfoPlugin deviceInfo = DeviceInfoPlugin();
    AndroidDeviceInfo androidInfo = await deviceInfo.androidInfo;
    FirebaseMessaging _fbm = FirebaseMessaging();
    print('Running on ${androidInfo.model}');  // e.g. "Moto G (4)"

    _fbm.getToken().then((token) async {
      var fullUrl = "https://apiapps.props.id/logMessageOpened?notificationId=${notificationId}&uuid=${androidInfo.androidId}";
      var url = Uri.parse(fullUrl);
      Map<String, String> headers = {
        "Authorization": PropsFlutterNotificationsdk.instance.getCoriginKeys()
      };
      var test = await http.get(url, headers: headers);
      print("YODAZO HTTPGET ${test.statusCode}");
      return;
    });
  }

  Future<void> callEvents(String notificationId) async {
    DeviceInfoPlugin deviceInfo = DeviceInfoPlugin();
    AndroidDeviceInfo androidInfo = await deviceInfo.androidInfo;
    FirebaseMessaging _fbm = FirebaseMessaging();
    print('Running on ${androidInfo.model}');  // e.g. "Moto G (4)"

    _fbm.getToken().then((token) async {
      var fullUrl = "https://apiapps.props.id/callEvent?eventId=${notificationId}&uuid=${androidInfo.androidId}";
      var url = Uri.parse(fullUrl);
      Map<String, String> headers = {
        "Authorization": PropsFlutterNotificationsdk.instance.getCoriginKeys()
      };
      var test = await http.get(url, headers: headers);
      print("YODAZO HTTPGET ${test.statusCode}");
      return;
    });
  }
}
